#include "inkey.ch"

Proc Xanthippe(pnTop, pnLeft, pbValue, pbCond, pbAts, pcBegin, pxAliasName, pxOrder, pxInitPos, pbSearch, paHelp)
  Local xI, xJ, xK, xL, oHat, aScope

 oHat := FedoraNew()
 oHat:stitch := {{K_DEL,,,,}, {K_BS,,,,}, {K_ENTER,,,,}}
 oHat:joint := {{, 0,, MAXCOL()}}
 oHat:nSet := 1
 if ValType(pxAliasName) $ 'CN'; dbSelectArea(pxAliasName); endif
 if pcBegin # Nil; aScope := MyScope(pcBegin); endif
 if !ISBLOCK(pbCond); pbCond := {|| .t.}; endif
 oHat:joint[1,1] := if(!ISNUMBER(pnTop) .or. pnTop < 1 .or. pnTop > MAXROW() -3, MAX(1, INT((MAXROW() -OrdKeyCount() -2) /2)), pnTop)
 oHat:joint[1,3] := MIN(MAXROW() -1, oHat:joint[1,1] +OrdKeyCount() +2)
 if ISCHARACTER(pbValue); pbValue := &('{||' +pbValue +'}'); endif
 xI := Len(Eval(pbValue))
 if ISCHARACTER(pbAts); pbAts := &("{||" +pbAts +"}"); endif
 if !ISARRAY(paHelp); paHelp := {}; endif
 AAdd(paHelp, 3)
 oHat:joint[1,2] := if(ISNUMBER(pnLeft), MIN(MAXCOL() -xI -1, pnLeft), MAX(0, INT((MAXCOL() -xI -1) /2)))
 oHat:joint[1,4] := MIN(oHat:joint[1,2] +xI +1, MAXCOL())
 NewWindow(oHat:joint[1], OrdKeyCount(), paHelp, K_CTRL_END, oHat:joint[1,1] +1, oHat:joint[1,3] -1)
 if pxInitPos # Nil; dbSeek(pxInitPos); endif
 oHat:stitch[3,3] := oHat:joint[1,2] +1
 oHat:stitch[3,4] := oHat:joint[1,4] -1
 oHat:nTop := oHat:joint[1,1] +1
 oHat:nLeft := oHat:joint[1,2] +1
 oHat:nBottom := oHat:joint[1,3]
 oHat:nRight := oHat:joint[1,4] -1
 xJ := FellerNew(, pbValue)
 xJ:width := xI
 xJ:colorBlock := {|| if(Eval(pbCond), {1, 2}, {5, 4})}
 oHat:addColumn(xJ)
 oHat:cargo := {EOF()}
 oHat:goTopBlock := {|| dbGoTo(LASTREC() +1), oHat:cargo[1] := .t.}
 oHat:goBottomBlock := {|| dbGoBottom(), oHat:cargo[1] := EOF()}
 refresh_db_var(oHat)
 While .t.
   While Empty(xI := INKEY()) .and. !oHat:stabilize(); end
   if Empty(xI)
     if oHat:hitTop .or. oHat:hitBottom
       oHat:hitTop := oHat:hitBottom := .f.
       TONE(300, 1); TONE(100, 2)
     endif
     if !oHat:autoLite; oHat:hilite():autoLite := .t.; endif
     oHat:forceStable()
     oHat:stitch[3, 2] := oHat:nTop +oHat:rowPos -1
     TabUpdate(OrdKeyNo(), oHat:rowPos)
     xI := WaitForInput(oHat:stitch)
   endif
   IF ApplyGlobalKey(oHat, xI) # K_CTRL_INS
   ELSEIF xI == K_DOWN
     While (oHat:down():forceStable(), !oHat:hitBottom .and. !Eval(pbCond)); end
   ELSEIF xI == K_UP
     While (oHat:up():forceStable(), !oHat:hitTop .and. !Eval(pbCond)); end
   ELSEIF xI == K_PGDN;	oHat:pageDown()
   ELSEIF xI == K_PGUP;	oHat:pageUp()
   ELSEIF xI == K_CTRL_PGUP .or. xI == K_CTRL_HOME .or. xI == K_HOME; oHat:goTop()
   ELSEIF xI == K_CTRL_PGDN .or. xI == K_CTRL_END .or. xI == K_END; oHat:goBottom()
   ELSEIF xI == K_INS; SET(_SET_INSERT, !SET(_SET_INSERT))
   ELSEIF xI == K_CTRL_DEL
     if (xI := GetMSLoc()) > (xJ := oHat:nTop +oHat:rowPos -1)
       For xJ := xJ +1 to xI; oHat:down(); next
     else
       For xI := xI +1 to xJ; oHat:up(); next
     endif
     oHat:forceStable()
     if !Eval(pbCond); TONE(300, 1); TONE(100, 2); endif
   ENDIF
 end
Return
